System.Gadget.onSettingsClosed = function(event) {
  if (event.closeAction == event.Action.commit) {
    setEvents();
  }
}

function setEvents(){
  var click=System.Gadget.Settings.readString("click");
  if (click=='double') {
    document.body.ondblclick=function() {System.Gadget.Flyout.show=!System.Gadget.Flyout.show;}
    document.body.onclick=null;
  } else {
    document.body.onclick=function() {System.Gadget.Flyout.show=!System.Gadget.Flyout.show;}
    document.body.ondblclick=null;
  }
}
  
function init() {
  if(document.readyState=="complete") {
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.Flyout.file = "flyout.html";
    setEvents();
  }        
}

function initFlyout() {
  var direct=
    (getSetting("target","ask8ball.net")!='ask8ball.net' &&
     getSetting("directanswer","false")!='false' );
  if (direct) {
    document.getElementById('question_div').style.display='none';
    document.getElementsByTagName('body')[0].style.height='50px';
    ask();
  }
}
  
function ask() {
	var target=getSetting("target","ask8ball.net");
	if (target=="ask8ball.net") {
    askRemote(document.getElementById('question').value,document.getElementById('answer'));
  } else {
    askLocal(document.getElementById('answer'));
  }
}

function askRemote(q,ae) {
  if (trim(q) != '') {
  	ae.innerHTML = 'Contacting Oracle..';
    var httpRequest;
    try {
      httpRequest = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
      try {
        httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e) {}
    }
    httpRequest.onreadystatechange = function() { oracleHandler(httpRequest); };

    var url='http://www.ask8ball.net/ajax/oracle/question/' + q;
    if (System.Gadget.Settings.readString("method")=='registered') {
      url+='/loginname/'+System.Gadget.Settings.readString("user")+'/loginpwd/'+System.Gadget.Settings.readString("pwd");
    }

    httpRequest.open('GET',url, true);
    
    httpRequest.send(null);

  } else {
  	document.getElementById('answer').innerHTML = 'You have to ask something';
  }
}

function oracleHandler(httpRequest) {
    if (httpRequest.readyState == 4) {
        if (httpRequest.status == 200) {
            document.getElementById('answer').innerHTML = httpRequest.responseText.split('|')[0];
        } else {
            alert('There was a problem with the request.');
        }
    }
}      

var answers=new Array(
     "As I see it, yes",
     "Ask again later",
     "Better not tell you now",
     "Cannot predict now",
     "Concentrate and ask again",
     "Don't count on it",
     "It is certain",
     "It is decidedly so",
     "Most likely",
     "My reply is no",
     "My sources say no",
     "Outlook good",
     "Outlook not so good",
     "Reply hazy, try again",
     "Signs point to yes",
     "Very doubtful",
     "Without a doubt",
     "Yes",
     "Yes - definitely",
     "You may rely on it");

function askLocal(ae) {
  ae.innerHTML=answers[Math.floor(answers.length*Math.random())];
}


function trim (str) {
	var	str = str.replace(/^\s\s*/, ''),
		ws = /\s/,
		i = str.length;
	while (ws.test(str.charAt(--i)));
	return str.slice(0, i + 1);
}

function keyboardOracleCall(e) {
  var keynum;
  if(window.event) { // IE
    keynum = e.keyCode;
  } else if(e.which) { // Netscape/Firefox/Opera
    keynum = e.which;
  }
  if (keynum == 13) {
    ask();
  } else {
    return String.fromCharCode(keynum);
  }
}

function getSetting(value, def) {
  var x=System.Gadget.Settings.readString(value);
  return x==''?def:x;
}