function getRadioValue(name){
  var els=document.getElementsByName(name);
  for (var i=0; i<els.length; i++)
    if (els[i].checked) return els[i].value;
}	

function setRadioValue(name,value){
  var els=document.getElementsByName(name);
  for (var i=0; i<els.length; i++)
    els[i].checked=(els[i].value==value);
}	

function loadAndSetRadio(value, elementName, defVal) {
  var x=System.Gadget.Settings.readString(value);
  setRadioValue(elementName,x==''?defVal:x);
}

function loadSettings() {
  System.Gadget.onSettingsClosing = settingsClosing;
  
  loadAndSetRadio("click", "s_click", "single");
  loadAndSetRadio("target", "s_target", "ask8ball.net");
  loadAndSetRadio("method", "s_method", "anonymous");
  loadAndSetRadio("directanswer", "s_directanswer", "false");
  document.getElementById("s_user").value=System.Gadget.Settings.readString("user");
  document.getElementById("s_pwd").value=System.Gadget.Settings.readString("pwd");
  
  refreshVisibility();
}

function saveSettings() {
  System.Gadget.Settings.writeString("click",getRadioValue("s_click"));
  System.Gadget.Settings.writeString("method",getRadioValue("s_method"));
  System.Gadget.Settings.writeString("target",getRadioValue("s_target"));
  System.Gadget.Settings.writeString("directanswer",getRadioValue("s_directanswer"));
  System.Gadget.Settings.writeString("user",document.getElementById("s_user").value);
  System.Gadget.Settings.writeString("pwd",document.getElementById("s_pwd").value);
}

function refreshVisibility() {
  if (getRadioValue("s_target")=='local') {
    document.getElementById('div_directanswer').style.display='block';
    document.getElementById('div_method').style.display='none';
    document.getElementById('table_userdata').style.display='none';
  } else {
    document.getElementById('div_directanswer').style.display='none';
    document.getElementById('div_method').style.display='block';
    if (getRadioValue("s_method")=='anonymous') {
      document.getElementById('table_userdata').style.display='none';
    } else {
      document.getElementById('table_userdata').style.display='block';
    }
  }
}

// --------------------------------------------------------------------
// Handle the Settings dialog closed event.
// event = Event argument.
// --------------------------------------------------------------------
var settingsClosing = function(event)
{
  // User hit OK on the settings page.
  if (event.closeAction == event.Action.commit) {
    saveSettings();
  }
}
